// $Id: ZoomOut.java 24229 2016-11-22 15:39:37Z mike $

package org.faceless.pdf2.viewer2.feature;

import org.faceless.pdf2.viewer2.*;
import org.faceless.pdf2.*;
import javax.swing.*;
import java.awt.event.*;
import java.awt.Insets;

/**
 * Create a button which zooms the document out to the next level.
 *
 * <span class="featurename">The name of this feature is <span class="featureactualname">ZoomOut</span></span>
 * <p><i>This code is copyright the Big Faceless Organization. You're welcome to use, modify and distribute it in any form in your own projects, provided those projects continue to make use of the Big Faceless PDF library.</i></p>
 * @since 2.8
 */
public class ZoomOut extends ViewerWidget
{
    public ZoomOut() {
        super("ZoomOut");
        setButton("Navigation", "resources/icons/ZoomOut.png", "PDFViewer.tt.ZoomOut");
        setMenu("View\tZoom\tZoomOut");
    }

    public void initialize(PDFViewer viewer) {
        super.initialize(viewer);
        if (getComponent() instanceof JButton) {
            JButton b = (JButton)getComponent();
            Insets i = b.getInsets();
            b.setMargin(new Insets(0, i.left, 0, 0));
        }
    }

    public void action(ViewerEvent event) {
        PDFViewer viewer = event.getViewer();
        DocumentPanel panel = viewer.getActiveDocumentPanel();
        float zoom = panel.getZoom();
        int[] intervals = viewer.getZoomIntervals();
        for (int i = intervals.length - 1; i >= 0; i--) {
            float level = ((float) intervals[i]) / 100f;
            if (level < zoom) {
                panel.setZoom(level);
                break;
            }
        }
    }
}
